/* REXX:make XPDF desktop objects */

Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysloadFuncs'
Call SysLoadFuncs

ExeDir=Directory()

Say 'Installing support for IBM-858 ..'
Call Add_IBM_858

Say 'Changing paths in batch files ..'
Call set_PATH_TO_XPDF 'pdftotext.cmd'
Call set_PATH_TO_XPDF 'pdfimages.cmd'
Call set_PATH_TO_XPDF 'pdftops.cmd'
Call set_PATH_TO_XPDF 'pdfinfo.cmd'

Say 'Attaching icons ..'
Call SysSetIcon "pdffonts.exe",  "xpdf.ico"
Call SysSetIcon "pdfimages.cmd", "xpdf.ico"
Call SysSetIcon "pdfimages.exe", "xpdf.ico"
Call SysSetIcon "pdfinfo.cmd",   "xpdf.ico"
Call SysSetIcon "pdfinfo.exe",   "xpdf.ico"
Call SysSetIcon "pdftops.cmd",   "xpdf.ico"
Call SysSetIcon "pdftops.exe",   "xpdf.ico"
Call SysSetIcon "pdftotext.cmd", "xpdf.ico"
Call SysSetIcon "pdftotext.exe", "xpdf.ico"

Say 'Creating objects ..'
call Create_WPS 'PDF to Text',       'pdftotext.cmd', '<PDFtoTEXT>'
call Create_WPS 'PDF Images',        'pdfimages.cmd', '<PDFImages>'
call Create_WPS 'PDF to PostScript', 'pdftops.cmd',   '<PDFtoPS>'
call Create_WPS 'PDF Info',          'pdfinfo.cmd',   '<PDFInfo>'

Say 'Done.'
Return 0

set_PATH_TO_XPDF:
  Parse Arg batchfilename
  
  linecount=0
  Call Stream batchfilename, 'C', 'Open Read'
  do while Lines(batchfilename)
    linecount=linecount+1
    line.linecount=LineIn(batchfilename)
    if Pos('if [%PATH_TO_XPDF%]==[] set PATH_TO_XPDF=',line.linecount)<>0 then
      line.linecount='if [%PATH_TO_XPDF%]==[] set PATH_TO_XPDF='ExeDir'\'
  end
  Call Stream batchfilename, 'C', 'Close'  
  
  Call Stream batchfilename, 'C', 'Open Write Replace'  
  do i=1 to linecount
    Call LineOut batchfilename, line.i
  end
  Call Stream batchfilename, 'C', 'Close'    
  
  Return
  
Create_WPS:
  Parse Arg title, command, oid
  
  Call SysCreateObject 'WPProgram', title, '<WP_DESKTOP>', 'EXENAME='ExeDir'\'command';PROGTYPE=PROG_WINDOWABLEVIO;STARTUPDIR='ExeDir';NOAUTOCLOSE=NO;ASSOCFILTER=*.pdf;ASSOCTYPE=PDF;OBJECTID='oid';', 'Replace'  
  
  Return 
  
  
Add_IBM_858:  
  profile=Value('HOME',, 'OS2ENVIRONMENT')
  if profile=='' then Return
  
  profile=profile'\.xpdfrc'
  Say profile
  
  linecount=0
  if Stream(profile, 'C', 'Query Exist')=='' then
    do
      line.1='# xpdf profile: read xpdfrc.cat for help'
      line.2='psPaperSize A4'
      line.3='textEOL DOS'
      line.4=''
      linecount=4
    end
  else
    do
      Call Stream profile, 'C', 'Open Read'
      do while Lines(profile)
        linecount=linecount+1
        line.linecount=LineIn(profile)
        if Pos('IBM-858.unicodeMap',line.linecount)<>0 then
          line.linecount='# 'line.linecount
        if Pos('textEncoding',line.linecount)<>0 then
          line.linecount='# 'line.linecount        
      end
      Call Stream profile, 'C', 'Close'  
    end
    
  linecount=linecount+1
  line.linecount='unicodeMap IBM-858 'ExeDir'\IBM-858.unicodeMap'
  linecount=linecount+1
  line.linecount='textEncoding IBM-858'
  
  Call Stream profile, 'C', 'Open Write Replace'  
  do i=1 to linecount
    Call LineOut profile, line.i
  end
  Call Stream profile, 'C', 'Close'    
  
  Return
  